---------------------------------------------------------------------------------------------------
-- Addon Manager
---------------------------------------------------------------------------------------------------
Global( "addon", {
	handlers = {},
	
	items = {},
	selected = {},
	sortedBy = {},
	
	textures = { 
		[ 0 ] = common.GetAddonRelatedGroupTexture( "ButtonSortStates", "SortNone" ),
		[ 1 ] = common.GetAddonRelatedGroupTexture( "ButtonSortStates", "SortUp" ),
		[ 2 ] = common.GetAddonRelatedGroupTexture( "ButtonSortStates", "SortDown" )
	},
	
	isListUpdated = true,
	overMainButton = false,
	
	DND_ID_BUTTON_MAIN = 1024,
	DND_ID_WINDOW_MAIN = 1025,
	PREFIX = "UserAddon/",
	--SLASH_COMMAND = "\/am"
} )
---------------------------------------------------------------------------------------------------
--[[
addon.handlers[ "EVENT_UNKNOWN_SLASH_COMMAND" ] = function( event )
	if addon.SLASH_COMMAND == FrWS( event.text ) then W( "MainPanel" ):Show( not W( "MainPanel" ):IsVisible() ) end
end--]]

addon.handlers[ "EVENT_SECOND_TIMER" ] = function()
	-->>>> debug
	if avatar.IsExist() and W( "MainPanel" ):IsVisible() then
		W( "Header" ):SetVal( "value", ToWS( "testAM memUsage = " .. gcinfo() ) )
	end
	--<<<<
	if not addon.isListUpdated then
		for _, v in pairs( common.GetStateManagedAddons() ) do
			W( "ButtonToggleAddonState", addon.items[ v.name ].w ):SetVariant( v.isLoaded and 1 or 0 )
			addon.items[ v.name ].state = v.isLoaded
			if HasNamePrefix( v.name ) then				
				W( "ButtonToggleDND", addon.items[ v.name ].w ):Enable( v.isLoaded )
				W( "ButtonShowHide", addon.items[ v.name ].w ):Enable( v.isLoaded )
				W( "ButtonSettings", addon.items[ v.name ].w ):Enable( v.isLoaded )
			end
		end
		addon:Update()
	end
end

addon.handlers[ "EVENT_AVATAR_CREATED" ] = function()
	for _, v in pairs( common.GetStateManagedAddons() ) do addon:AddItem( v ) end
	local widget = addon.sort[ "SortPanel" ][ "SortByName" ]
	W( "ButtonSort", widget ):SetVariant( 1 )
	W( "ButtonSortState", widget ):SetBackgroundTexture( addon.textures[ 1 ] )
	addon:SortBy( "SortByName", true )
	addon.isListUpdated = false
end

addon.handlers[ "SCRIPT_ADDON_INFO_RESPONSE" ] = function( event )
	local sender = addon.PREFIX .. event.sender
	local item = addon.items[ sender ]	
	if item then
		if event.desc then
			--event.desc = type( event.desc ) == "string" and ToWS( event.desc ) or event.desc
			item.comment = event.desc
			W( "Comment", item.w ):SetVal( "value", ToWS( item.comment ) )
		end
		if event.showDNDButton then
			item.isLocked = addon.config.avatar and addon.config.avatar[ sender ] and addon.config.avatar[ sender ].isLocked or false
			W( "ButtonToggleDND", item.w ):Show( true )
			W( "ButtonToggleDND", item.w ):SetVariant( item.isLocked and 1 or 0 )
			userMods.SendEvent( "SCRIPT_TOGGLE_DND", { target = event.sender, state = item.isLocked } )
		end
		if event.showHideButton then W( "ButtonShowHide", item.w ):Show( true ) end
		if event.showSettingsButton then W( "ButtonSettings", item.w ):Show( true ) end
		item.list = event.list
	end
end

addon.handlers[ "SCRIPT_TOGGLE_UI" ] = function( event ) mainForm:Show( event.visible ) end

addon.handlers[ "mouse_left_click" ] = function( reaction )
	local parent = reaction.widget:GetParent()
	local parentName = parent:GetName()
	local var = reaction.widget:GetVariant() == 1
	local isSelected = table.getn( addon.selected ) > 0
	if reaction.sender == "ButtonMain" then
		local isInvisible = not W( "MainPanel" ):IsVisible()
		W( "MainPanel" ):Show( isInvisible )
		DnD:Enable( W( "MainPanel" ), isInvisible )
		return
	elseif reaction.sender == "ButtonItem" then
		if parentName == addon.PREFIX .. common.GetAddonName() then return end
		local arr = addon.selected		
		if not var then table.insert( arr, parentName ) else for i, v in ipairs( arr ) do if v == parentName then table.remove( arr, i ) end end end
		reaction.widget:SetVariant( var and 0 or 1 )
		isSelected = table.getn( addon.selected ) > 0
		W( "ButtonLoadSelected" ):Enable( isSelected );	W( "ButtonUnLoadSelected" ):Enable( isSelected )
		return
	elseif reaction.sender == "TabUser" or reaction.sender == "TabDefault" then
		var = reaction.sender == "TabDefault"
		W( "TabDefault" ):SetVariant( var and 1 or 0 ); W( "TabUser" ):SetVariant( var and 0 or 1 )
		W( "SortPanel" ):Show( not var ); W( "SortPanelDefault" ):Show( var )
		addon.isDefaultShowed = var
		var = var and "SortPanelDefault" or "SortPanel"
		local sortedBy = addon.sortedBy[ var ] or { "SortByName", 1 }
		parent = addon.sort[ var ][ sortedBy[ 1 ] ]
		W( "ButtonSort", parent ):SetVariant( sortedBy[ 2 ] )
		W( "ButtonSortState", parent ):SetBackgroundTexture( addon.textures[ sortedBy[ 2 ] ] )
		addon:SortBy( sortedBy[ 1 ], sortedBy[ 2 ] == 1 )
		return
	elseif string.find( parentName, "SortBy" ) then
		local widget = W( "ButtonSortState", parent )
		local variant = ( { [ 0 ] = 1, [ 1 ] = 2, [ 2 ] = 1 } )[ reaction.widget:GetVariant() ]
		local grandpaName = parent:GetParent():GetName()
		for k, v in pairs( addon.sort[ grandpaName ] ) do
			W( "ButtonSort", v ):SetVariant( 0 )
			W( "ButtonSortState", v ):SetBackgroundTexture( addon.textures[ 0 ] )
		end
		reaction.widget:SetVariant( variant )
		widget:SetBackgroundTexture( addon.textures[ variant ] )
		addon.sortedBy[ grandpaName ] = { parentName, variant }
		addon:SortBy( parentName, not var )
		return
	elseif reaction.sender == "ButtonLoadAll" then
		for k, v in pairs( addon.items ) do if HasNamePrefix( k ) then addon:ToggleAddonState( k, true ) end end
	elseif reaction.sender == "ButtonUnLoadAll" then
		for k, v in pairs( addon.items ) do if HasNamePrefix( k ) and k ~= addon.PREFIX .. common.GetAddonName() then addon:ToggleAddonState( k ) end end
	elseif reaction.sender == "ButtonToggleDND" then
		userMods.SendEvent( "SCRIPT_TOGGLE_DND", { target = GetName( parentName ), state = not var } )
		addon.items[ parentName ].isLocked = not var
		reaction.widget:SetVariant( var and 0 or 1 )
		return
	elseif reaction.sender == "ButtonShowHide" then
		userMods.SendEvent( "SCRIPT_TOGGLE_VISIBILITY", { target = GetName( parentName ), isVisible = not var } )
		addon.items[ parentName ].isVisible = not var
		reaction.widget:SetVariant( var and 0 or 1 )
		return
	elseif reaction.sender == "ButtonSettings" then
		userMods.SendEvent( "SCRIPT_SHOW_SETTINGS", { target = GetName( parentName ) } )
		return
	elseif reaction.sender == "ButtonCornerCross" then
		W( "MainPanel" ):Show( false )
		return
	elseif reaction.sender == "ButtonSave" then
		addon:SaveConfig()
		return
	elseif reaction.sender == "ButtonReset" then
	--
	elseif reaction.sender == "ButtonToggleAddonState" then
		addon:ToggleAddonState( parentName, not var )
		addon.items[ parentName ].state = not var
	end
	if isSelected then
		if reaction.sender == "ButtonLoadSelected" then for _, v in ipairs( addon.selected ) do addon:ToggleAddonState( v, true ) end
		elseif reaction.sender == "ButtonUnLoadSelected" then for _, v in ipairs( addon.selected ) do addon:ToggleAddonState( v ) end
		end
	end
	if reaction.widget:GetVariantCount() > 1 then reaction.widget:SetVariant( var and 0 or 1 ) end
	addon:Update( true )
end

addon.handlers[ "mouse_over" ] = function( reaction ) end
addon.handlers[ "mouse_right_click" ] = function( reaction ) end
---------------------------------------------------------------------------------------------------
addon.AddItem = function( self, v )
	local config = {
		global = self.config.global[ v.name ],
		avatar = self.config.avatar[ v.name ]
	}		
	local widget
	if HasNamePrefix( v.name ) then
		if not self.itemDesc then
			widget = W( "Item" )
			self.itemDesc = widget:GetWidgetDesc()
		else
			widget = mainForm:CreateWidgetByDesc( self.itemDesc )
		end
	else
		if not self.itemDescDef then
			widget = W( "ItemDefault" )
			self.itemDescDef = widget:GetWidgetDesc()
		else
			widget = mainForm:CreateWidgetByDesc( self.itemDescDef )
		end
	end
	widget:SetName( v.name )
	local item = {
		w = widget,
		--comment = config and config.comment or "-",
		comment = type( config.global ) ~= "table" and config.global or v.name,
		state = not ( config.avatar and not config.avatar.state )
	}
	if not item.state then self:ToggleAddonState( v.name ) end	
	W( "ButtonToggleAddonState", item.w ):SetVariant( item.state and 1 or 0 )
	if v.name == self.PREFIX .. common.GetAddonName() then W( "ButtonToggleAddonState", item.w ):Show( false ) end
	W( "Name", item.w ):SetVal( "value", ToWS( GetName( v.name ) ) )
	W( "Comment", item.w ):SetVal( "value", ToWS( item.comment ) )
	self.items[ v.name ] = item
	userMods.SendEvent( "SCRIPT_ADDON_INFO_REQUEST", { target = GetName( v.name ) } )
end

addon.Init = function( self )
	self.config = {
		global = userMods.GetGlobalConfigSection( common.GetAddonName() ) or {},
		avatar = userMods.GetAvatarConfigSection( common.GetAddonName() ) or {}
	}
	DnD:Init( self.DND_ID_BUTTON_MAIN, W( "ButtonMain" ), nil, false )
	DnD:Init( self.DND_ID_WINDOW_MAIN, W( "Header" ), W( "MainPanel" ), false )
	DnD:Enable( W( "MainPanel" ), false )
	--
	--debug W( "Header" ):SetVal( "value", ToWS( L[ "Addon Manager" ] ) )
	W( "TabUser" ):SetVal( "button_label", ToWS( L[ "User" ] ) )
	W( "TabUser" ):SetVariant( self.isDefaultShowed and 0 or 1 )
	W( "TabDefault" ):SetVal( "button_label", ToWS( L[ "Default" ] ) )
	W( "TabDefault" ):SetVariant( self.isDefaultShowed and 1 or 0 )
	--W( "ButtonToggleUI" ):SetVal( "button_label", ToWS( addon.isUIShowed and L[ "Hide All" ] or L[ "Show All" ] ) )
	W( "ButtonLoadSelected" ):SetVal( "button_label", ToWS( L[ "Load Selected" ] ) )
	W( "ButtonUnLoadSelected" ):SetVal( "button_label", ToWS( L[ "Unload Selected" ] ) )
	W( "ButtonLoadAll" ):SetVal( "button_label", ToWS( L[ "Load All" ] ) )
	W( "ButtonUnLoadAll" ):SetVal( "button_label", ToWS( L[ "Unload All" ] ) )
	W( "ButtonSave" ):SetVal( "button_label", ToWS( L[ "Save" ] ) )
	W( "ButtonReset" ):SetVal( "button_label", ToWS( L[ "Reset" ] ) )
	--
	for _, v in { W( "SortPanel" ), W( "SortPanelDefault" ) } do
		W( "ButtonSort", W( "SortByName", v ) ):SetVal( "button_label", ToWS( L[ "Name" ] ) )
		W( "ButtonSort", W( "SortByComment", v ) ):SetVal( "button_label", ToWS( L[ "Comment" ] ) )
	end
	--
	local function GetWidgets( group )
		local tab = {}
		for _, v in pairs( W( group ):GetNamedChildren() ) do tab[ v:GetName() ] = v end
		return tab
	end
	self.sort = { [ "SortPanel" ] = GetWidgets( "SortPanel" ), [ "SortPanelDefault" ] = GetWidgets( "SortPanelDefault" ) }
	--
	self:Reg()
	if avatar.IsExist() then addon.handlers[ "EVENT_AVATAR_CREATED" ]() end
	--self.Init = nil
end

addon.Reg = function( self )
	for k, v in pairs( self.handlers ) do if string.find( k, "[A-Z]+_" ) then common.RegisterEventHandler( v, k ) else common.RegisterReactionHandler( v, k ) end end
end

addon.SortBy = function( self, name, order )
	local colors = {
		{ r = 255 / 255, g = 185 / 255, b = 255 / 255, a = 1.0 },
		{ r = 255, g = 255, b = 255, a = 1.0 }
	}
	local array, tab, result = {}
	local case = {
		[ "SortByState" ] = function()
			for k, v in pairs( self.items ) do
				tab = { state = tonumber( v.state ), name = k }
				if self.isDefaultShowed then if not HasNamePrefix( k ) then table.insert( array, tab ) end
				else if HasNamePrefix( k ) then table.insert( array, tab ) end
				end
			end
			table.sort( array, function( a, b )
				if a.state == b.state then result = a.name < b.name
				else if order then result = a.state < b.state else result = a.state > b.state end
				end
				return result
			end )
		end,
		[ "SortByName" ] = function()
			for k, v in pairs( self.items ) do
				if self.isDefaultShowed then if not HasNamePrefix( k ) then table.insert( array, k ) end
				else if HasNamePrefix( k ) then table.insert( array, k ) end
				end
			end
			table.sort( array, function( a, b ) if order then return a < b else return a > b end end )
		end,
		[ "SortByComment" ] = function()
			for k, v in pairs( self.items ) do
				tab = { name = k, comment = v.comment or "" }
				if self.isDefaultShowed then if not HasNamePrefix( k ) then table.insert( array, tab ) end
				else if HasNamePrefix( k ) then table.insert( array, tab ) end
				end
			end
			table.sort( array, function( a, b )
				if a.comment == b.comment then result = a.name < b.name
				else if order then result = a.comment < b.comment else result = a.comment > b.comment end
				end
				return result
			end )
		end,
		[ "SortByDNDState" ] = function()
			for k, v in pairs( self.items ) do
				if HasNamePrefix( k ) then
					tab = { isDnDButtonShowed = tonumber( W( "ButtonToggleDND", v.w ):IsVisible() and v.state ), isLocked = tonumber( v.isLocked ), name = k }
					table.insert( array, tab )
				end
			end
			table.sort( array, function( a, b )
				if a.isDnDButtonShowed == b.isDnDButtonShowed then
					if a.isLocked == b.isLocked then result = a.name < b.name
					else if order then result = a.isLocked < b.isLocked else result = a.isLocked > b.isLocked end
					end
				else
					if order then result = a.isDnDButtonShowed < b.isDnDButtonShowed else result = a.isDnDButtonShowed > b.isDnDButtonShowed end
				end
				return result
			end )
		end,
		[ "SortByVisibility" ] = function()	
			for k, v in pairs( self.items ) do
				if HasNamePrefix( k ) then
					tab = { isHideButtonShowed = tonumber( W( "ButtonShowHide", v.w ):IsVisible() and v.state ), isVisible = tonumber( v.isVisible ), name = k }
					table.insert( array, tab )
				end
			end
			table.sort( array, function( a, b )
				if a.isHideButtonShowed == b.isHideButtonShowed then
					if a.isVisible == b.isVisible then result = a.name < b.name
					else if order then result = a.isVisible > b.isVisible else result = a.isVisible < b.isVisible end
					end
				else if order then result = a.isHideButtonShowed < b.isHideButtonShowed else result = a.isHideButtonShowed > b.isHideButtonShowed end
				end
				return result
			end )
		end,
		[ "SortBySettings" ] = function()
			for k, v in pairs( self.items ) do
				if HasNamePrefix( k ) then
					tab = { isSettingsButtonShowed = tonumber( W( "ButtonSettings", v.w ):IsVisible() and v.state ), name = k }
					table.insert( array, tab )
				end
			end
			table.sort( array, function( a, b )
				if a.isSettingsButtonShowed == b.isSettingsButtonShowed then result = a.name < b.name
				else if order then result = a.isSettingsButtonShowed > b.isSettingsButtonShowed else result = a.isSettingsButtonShowed < b.isSettingsButtonShowed end
				end
				return result
			end )
		end
	}
	case[ name ]()--]]
	W( "Container" ):RemoveItems()
	for i, v in ipairs( array ) do
		v = type( v ) == "string" and v or v.name
		local widget = self.items[ v ].w
		W( "Container" ):PushBack( widget )
		if not widget:IsVisible() then widget:Show( true ) end
		widget = W( "ButtonItem", widget )
		if math.mod( i, 2 ) == 0 then widget:SetBackgroundColor( colors[ 1 ] ) else widget:SetBackgroundColor( colors[ 2 ] ) end
	end
end

addon.SaveConfig = function( self )
	for k, v in pairs( self.items ) do
		self.config.avatar[ k ] = { state = v.state }
		if HasNamePrefix( k ) and W( "ButtonToggleDND", v.w ):IsVisible() then self.config.avatar[ k ].isLocked = not not v.isLocked end
		if v.comment ~= "-" and not self.config.global[ k ] then self.config.global[ k ] = v.comment end		
	end
	userMods.SetGlobalConfigSection( common.GetAddonName(), self.config.global )
	userMods.SetAvatarConfigSection( common.GetAddonName(), self.config.avatar )
end

addon.Update = function( self, b )
	local b = not b
	self.isListUpdated = b
	W( "MainPanel" ):SetFade( b and 1.0 or 0.9 )
	W( "MainPanel" ):Enable( b )
end

addon.ToggleAddonState = function( self, name, state )
	if state then
		common.StateLoadManagedAddon( name )
		userMods.SendEvent( "SCRIPT_ADDON_INFO_REQUEST", { target = GetName( name ) } )
	else
		common.StateUnloadManagedAddon( name )
		if self.items[ name ] and self.items[ name ].list then for _, v in ipairs( self.items[ name ].list ) do common.StateLoadManagedAddon( v ) end end
	end
end
---------------------------------------------------------------------------------------------------
function W( s, wt ) return wt and wt:GetChildChecked( s, true ) or mainForm:GetChildChecked( s, true ) end
function ToWS( s ) return userMods.ToWString( s ) end
function FrWS( ws ) return userMods.FromWString( ws ) end

function HasNamePrefix( name ) local _, pos = string.find( name, addon.PREFIX ) return pos end
function GetName( name ) return string.sub( name, tonumber( HasNamePrefix( name ) ) + 1 ) end
---------------------------------------------------------------------------------------------------
addon:Init()
---------------------------------------------------------------------------------------------------